-----------------------------------------------------------------------------
-- Name ----> Vector                 ---   Vector graphics Asteroid clone  --
-- Filename > VECTOR.EX              ---       ---=={Free|ware}==---       --
-- Author --> Robert B. Pilkington   --- See later documentation for       --
-- Version -> 0.90.00                --- descriptions on what needs to be  --
-- Date ----> 01/25/1999             --- done to finish this game          --
-----------------------------------------------------------------------------

-- Note - Don't rely too much on the documentation in this file.
-- I have to update it, but don't feel like it. :)
-- Ignore the date at the top.. I don't know when the last time I made
-- modifications was. The only modifications made this time was this extra
-- 'warning' documentation, so it doesn't count. I think.
-- I'll clean this all up sometime. Until then, just play the game.

-- As you look through this code, you may notice some optimizations I have
-- done, especially for displaying graphics. Of course, I'm sure there are
-- plenty more optimizations that can be made, but what I have done so far
-- is holding off erasing each object until just before it is moved. This
-- greatly reduces flicker. (Since I'm not using a virtual screen.) If I
-- had erased all of each object first, the flicker would be horrible. This
-- requires a slight adjustment for those who are used to bitmapped graphics.
-- (Where all objects must be erased before anything can be drawn, otherwise
-- there will be horrible graphics corruption bugs...)

-- Also, check out the AI code. I have just updated it to use 3 different
-- classes of AI. The Rookie class aims at where you are now. The Veteran
-- class uses my first rule method. It faces in one of 8 directions and seems
-- pretty smart. The Ace class leads you and is VERY effective. I would have
-- used only Ace, but it is just way too effective. :-) Hope you don't get
-- stuck with too many on them on a level. ;-)

-- Other highlights are:
-- Rock generation code. It starts the rocks off as squares then randomizes
-- them to look like asteroids. You'd never know it if I didn't say anything!
-- (Or you didn't find it out yourself... :)

-- Note:
-- There *IS* a bug somewhere! The only problem is, I don't know where it is.
-- It happens sometimes when you die, but it is *VERY* rare, and has only
-- occured a few times. It's also hard to track down because I don't know
-- the conditions of the way you die that causes the bug, and due to the
-- random nature of this game. Unless you play it 30 times a day, you
-- probably won't come across it. It happens like once every 1000 games. (Ok,
-- so I don't know the actual percentage of times... it's just rare, but
-- does happen. Please report as much as you can if you find it.)
-- Michael Packard has the same type of problem in OidZone. I made it crash
-- once, but haven't been able to do it again. (Okay, when I register
-- Euphoria, I should be able to track down the bug, once it happens
-- again . . .) Until then, either give me the EX.ERR, or tell me as best
-- you can what was happening. I will look for similarities between reports
-- and try to track it down.


-- Recent updates:

-- Pre-Release Update #3
-- * Optimized particle system slightly (Using aliasing)
-- * You now have to switch secondary weapons
-- * Improved keyboard layout
-- * Rocks now smash into the enemy fighters. Fly into a saturated area
--   and watch the fighters crash into the rocks and die! (Too bad you don't
--   get points for that.. heh, heh, heh... :)
-- * Improved bomb explosion effects.
-- * Minor speed enhancements
-- * Spaces no longer work in high score list. (Makes it easier.)
-- * Major code clean-up (Okay, so it's still in progress . . .)
-- * Takes advantage of Euphoria 2.1 features
-- * Optimized the Vector Font routines *MUCH* more.
-- * Updated AI to have 3 different styles: Rookie, Veteran, and Ace.
--   Because of their effectiveness, the harder pilots don't show up on the
--   first level.
-- * Changed the way the coordinants were accessed. The new method is
--   clearer and hopefully faster. :-)
-- * Missiles now home in on nearest enemy. Also improved collision
--   detection with them. GO HOMERS!!
-- * Shield powerup

-- Pre-Release Update #2
-- * Added a little work on bouncing the ship. Not implimented yet!
-- * Took away the enemy fighters favorite toy: SuperRapidFire
--   They can now only fire as fast as you can when you pick up one rapidfire
--   (pick up two and you'll fire faster than they can)
--   They usually fire about as fast as you can with no rapidfires, though.

-- Pre-Release Update #1
-- * Added missiles
-- * Added double guns
-- * Changed look of spreadfire powerup. (Doesn't look much better, but
--   it is more meaningful)

-- To do:
-- Add more powerups (Done partally)
-- Make code more flexible (Work in progress)
-- Optimize performance (Ditto)
-- More types of enemies

without type_check                  -- Speed game up a little bit (I hope!)

--Includes
include graphics.e                  -- video mode and polygons
include keyread.e                   -- special keyboard handler
include file.e                      -- for allow_break(0)
include get.e                       -- For high score handling
include vfont.e                     -- Vector graphics fonts
include misc.e

--Setup constants
-- Keys
constant right = 333, left = 331, up = 328, spacebar = 57
constant l_alt = 56, r_alt = 312, l_ctrl = 29, r_ctrl = 285
constant l_shift = 42, r_shift = 54
constant esc = 1, pause_key = 25

constant rot = 10, -- Player and enemy rotational speed
         VIDEO_MODE = 18            -- 18, VGA 640x480 16 color
-- Array fields
constant X=1, Y=2
constant POS=1,VELOCITY=2,COLOR=3,TIMER=4,ALIVE=4,MAX_ALIVE=5, SHAPE=6,SIZE=7
constant ROTATION=8,ANGLE=8, TAG=9, WEAPON_RATE=10,WEAPON_TIMER=11
constant AI_CLASS=12
constant PARTICLE_FIELDS=4, FIELDS = 12

-- High score fields
constant NAME = 1, SCORE = 2, LEVEL = 3

-- Variables. Yes, I know, I *REALLY* need to make these not global, but
-- it's a little late for that, but it'll get done eventually...
object junk
object temp, temp2 --Yup, another temp... Oh, yeah... DON'T TAKE THIS OUT!
sequence input, player, rocks, shots, particles, sats, powerups, bomb
sequence enemy, missile, scores
-- sequence video_type, sin_lookup, cos_lookup, scores
atom quit, player_shot_length
atom sat_shot_length
atom player_top_speed, shot_speed, player_accel, level, display_timer
atom score, spreadfire, bombs, double_guns, missiles
atom high_score
integer current_weapon
sequence current_weapon_shape
integer weapon_switch_delay, weapon_switch_timer

-- Lookup tables for increased performance.
junk = {{},{}}
for j = 1 to 360 do
    junk[1] = append(junk[1], sin(j*PI/180))
    junk[2] = append(junk[2], cos(j*PI/180))
end for
constant sin_lookup = junk[1], cos_lookup = junk[2]

allow_break(0)                      -- Disable CTRL-BREAKing

--Setup graphics
junk = graphics_mode(VIDEO_MODE)    -- Set graphics mode.
constant video_type = video_config()

-- Not needed right now, but may be needed later.
--unction abs(atom number)           -- Get the absolute value of a number
--    if number < 0 then
--        number = -number
--    end if
--    return number
--end function

function Distance(sequence obj1, sequence obj2)
    -- Return the distance between obj1 and obj2
    atom x, y
    -- It is actually faster to do these one at a time:
    x = power(obj1[X] - obj2[X], 2)
    y = power(obj1[Y] - obj2[Y], 2)
    return sqrt(x + y)
end function

function Angle(sequence obj1, sequence obj2)
    -- Returns angle from obj1 to obj2
    atom angle, x, y
    x = obj1[X]-obj2[X]
    y = obj1[Y]-obj2[Y]
    if y then angle = -(arctan(x/y) * 180 / PI) + 90
    else angle = 90 end if
    if y > 0 then angle += 180 end if -- target above
    if angle > 360 then angle-=360
    elsif angle<=0 then angle+=360
    end if
    return angle
end function

function To_Target(sequence obj1, sequence obj2, sequence obj2v)
    -- Returns the angle needed for obj1 to face obj2, given
    -- the speed of obj2 in obj2v. WARNING: Dangerously effective!!! :-)
    atom angle
    obj2 += obj2v*(Distance(obj1, obj2)/shot_speed)
    angle = Angle(obj1, obj2)
    return angle
end function

function Can_See(sequence obj1, sequence obj2, atom angle, atom fov)
    integer target
    fov/=2 -- Halve the viewing angle
    target = floor(Angle(obj1, obj2) - angle)
    if target <= fov and target >= -fov then
        target=1
    else
        target=0
    end if
    return target
end function

function Collide(sequence obj1, sequence obj2, integer size1)
    -- Checks to see if obj1 and obj2 have collided, based on the size
    -- given by size1.
    -- I am debating whether the circular distance or a square bounding
    -- box is a better choice. The square bounding box seems to give better
    -- results.
    --if Distance(obj1, obj2) <= size1 then
    if obj1[X] >= obj2[X] - size1 and
    obj1[X] <= obj2[X] + size1 and
    obj1[Y] >= obj2[Y] - size1 and
    obj1[Y] <= obj2[Y] + size1 then
        return 1
    else
        return 0
    end if
end function

procedure tick_delay(atom ticks)
    atom oldtime
    for i = 1 to ticks do
        oldtime = time()
        while oldtime=time() do end while
    end for
end procedure

function Setup_Object(integer fields)
    sequence this
    this = repeat(0, fields)
    this[POS] = {0,0}
    this[VELOCITY] = {0,0}
    if fields >= SHAPE then
        this[SHAPE] = {}
    end if
    return this
end function

procedure Draw_Object(integer color, sequence shape, sequence xy)
    shape += repeat(xy, length(shape))
    polygon(color, 0, shape)
end procedure

function Rotate(sequence shape, atom speed)
    for i = 1 to length(shape) do
        shape[i] = {
         (shape[i][X] * cos_lookup[speed])-(shape[i][Y] * sin_lookup[speed]),
         (shape[i][Y] * cos_lookup[speed])+(shape[i][X] * sin_lookup[speed])}
    end for
    return shape
end function

function Wrap(sequence xy)
    if xy[X] > video_type[VC_XPIXELS] then
        xy[X] -= video_type[VC_XPIXELS]
    elsif xy[X] < 0 then
         xy[X] += video_type[VC_XPIXELS]
    end if
    if xy[Y] > video_type[VC_YPIXELS] then
        xy[Y] -= video_type[VC_YPIXELS]
    elsif xy[Y] < 0 then
        xy[Y] += video_type[VC_YPIXELS]
    end if
    return xy
end function

procedure Create_Particle(sequence xy, integer angle, object speed, integer timer)
    sequence particle
    particle = Setup_Object(PARTICLE_FIELDS)
    particle[POS] = xy
    particle[VELOCITY] = speed * {cos_lookup[angle], sin_lookup[angle]}
    particle[TIMER] = timer
    particle[COLOR] = (rand(2)*8) + (rand(3)+3)
    particles = append(particles, particle)
end procedure

procedure get_high_scores()
    integer fn
    fn = open("VECTOR.HI", "r")
    if fn = -1 then
        scores = repeat({"---", 0, 0}, 10)
    else
        scores = get(fn)
        if scores[1] = GET_SUCCESS then
            scores = scores[2]
        else
            scores = repeat({"---", 0, 0}, 10)
        end if
        close(fn)
    end if
end procedure

procedure put_high_scores()
    integer fn
    fn = open("VECTOR.HI", "w")
    if fn >= 0 then
        print(fn, scores)
        close(fn)
    end if
end procedure

procedure New_High_Score()
    VFcenter(3, "Enter your initials:", 3)
    VFcenter(4, scores[high_score][NAME] & '_', 0)
    temp = get_key()
    clear_keys()
    if temp = 13 then
        high_score = 0
        clear_screen()
    elsif temp = 8 then
        if length(scores[high_score][NAME]) > 0 then
            scores[high_score][NAME]=
            scores[high_score][NAME][1..length(scores[high_score][NAME])-1]
        end if
    elsif temp > 32 and temp <= 255 then
        if length(scores[high_score][NAME]) < 3 then
            scores[high_score][NAME] &= temp
        end if
    end if
    if high_score then
        VFcenter(4, scores[high_score][NAME] & '_', 3)
    end if
end procedure

procedure next_level()              -- Goto the next level
    level += 1
    display_timer = 50
    for i = 1 to rand(level+1) do
        rocks = append(rocks, Setup_Object(FIELDS))
        temp = 3
        -- Generate random shape for rock, start with 8 point square.
        rocks[i][SHAPE] = 
         ({{10,10},{10,0},{10,-10},{0,-10},{-10,-10},{-10,0},{-10,10},
         {0,10}} - 5)
        -- Modify square into something else... maybe an asteroid? :)
        for j = 1 to 8 do
            rocks[i][SHAPE][j][X] = (rocks[i][SHAPE][j][X] + rand(10))*temp
            rocks[i][SHAPE][j][Y] = (rocks[i][SHAPE][j][Y] + rand(10))*temp
        end for
        -- See, it worked... Now stop wondering how I got so many different
        -- asteroid shapes to come out, and how come they all looked cooler
        -- than the ones in Asteroids . . . ;)
        rocks[i][SIZE] = (10 * temp)
        rocks[i][POS][X] = rand(video_type[VC_XPIXELS])
        rocks[i][POS][Y] = rand(video_type[VC_YPIXELS])
        while (rocks[i][POS][X]>player[POS][X]-100 and rocks[i][POS][X]<player[POS][X]+100) and
         (rocks[i][POS][Y] > player[POS][Y]-100 and rocks[i][POS][Y] < player[POS][Y]+100) do
            rocks[i][POS][X] = rand(video_type[VC_XPIXELS])
            rocks[i][POS][Y] = rand(video_type[VC_YPIXELS])
        end while
        temp = rand(360)
        rocks[i][VELOCITY][X] = rand(3) * cos_lookup[temp]
        rocks[i][VELOCITY][Y] = rand(3) * sin_lookup[temp]
        rocks[i][ROTATION] = rand(20)-10
        if rocks[i][ROTATION] <= 0 then
            rocks[i][ROTATION] = rocks[i][ROTATION] + 359
        end if
        temp = rand(5)
        if temp = 1 then temp = 2
        elsif temp = 2 then temp = 10
        elsif temp = 3 then temp = 8
        elsif temp = 4 then temp = 7
        elsif temp = 5 then temp = 6
        end if
        rocks[i][COLOR] = temp
        rocks[i][ALIVE] = 1
    end for
    -- Generate new satellites
    for i = 1 to rand(level+2)-1 do
        sats = append(sats, Setup_Object(FIELDS))

        sats[i][SHAPE] = {{0,-10},{-10,10},{10,10},{0,-10},
         {0,0},{-10,10},{0,0},{10,10}}
        sats[i][SIZE] = 10
        sats[i][POS][X] = rand(video_type[VC_XPIXELS])
        sats[i][POS][Y] = rand(video_type[VC_YPIXELS])
        while (sats[i][POS][X]>player[POS][X]-100 and sats[i][POS][X]<player[POS][X]+100) and
         (sats[i][POS][Y] > player[POS][Y]-100 and sats[i][POS][Y] < player[POS][Y]+100) do
            sats[i][POS][X] = rand(video_type[VC_XPIXELS])
            sats[i][POS][Y] = rand(video_type[VC_YPIXELS])
        end while
        temp = rand(360)
        sats[i][VELOCITY][X] = rand(3) * cos_lookup[temp]
        sats[i][VELOCITY][Y] = rand(3) * sin_lookup[temp]
        sats[i][ROTATION] = rand(20)-10
        if sats[i][ROTATION] <= 0 then
            sats[i][ROTATION] = sats[i][ROTATION] + 359
        end if
        sats[i][COLOR] = 15
        sats[i][ALIVE] = 1
    end for
    -- Generate new enemy fighters
    for i = 1 to level do -- + rand(level+1)-1 do
        enemy = enemy & {Setup_Object(FIELDS)}
        enemy[i][POS][X] = rand(video_type[VC_XPIXELS])
        enemy[i][POS][Y] = rand(video_type[VC_YPIXELS])
        while Distance(enemy[i][POS], player[POS]) <
            shot_speed*player_shot_length do
            enemy[i][POS][X] = rand(video_type[VC_XPIXELS])
            enemy[i][POS][Y] = rand(video_type[VC_YPIXELS])
        end while
        enemy[i][VELOCITY][X]= rand(7)-4 enemy[i][VELOCITY][Y]=rand(7)-4
        enemy[i][ALIVE] = 2
        enemy[i][MAX_ALIVE]=2
        enemy[i][SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
        enemy[i][COLOR] = 12
        enemy[i][SIZE] = 6
        enemy[i][ANGLE] = 270
        enemy[i][TAG] = 2
        enemy[i][WEAPON_RATE] = 6
        enemy[i][WEAPON_TIMER] = 0
        enemy[i][AI_CLASS] = rand(3)
        if enemy[i][AI_CLASS]=3 then
            enemy[i][AI_CLASS]=rand(2)+1
        end if
        if enemy[i][AI_CLASS] > level then
            enemy[i][AI_CLASS] = 1
        end if
        if enemy[i][AI_CLASS]=3 then
            enemy[i][COLOR]-=8
        end if
    end for
end procedure

procedure update_player()           -- Update the player
    -- Erase status bar
    pixel(repeat(4, player[MAX_ALIVE]*10), {1,1})
    for j = 1 to (bombs+1)*4 by 4 do
        pixel({0,0,0},{j-1, 5})
        pixel(0, {j, 4})
        pixel(0, {j, 6})
    end for
    for j = 1 to (missiles+1)*4 by 4 do
        pixel(0,{j, 9})
        pixel(0, {j-1, 10})
        pixel(0, {j+1, 10})
    end for
    -- Draw bombs
    for j = 1 to bombs*4 by 4 do
        pixel({12,12,12},{j-1, 5})
        pixel(12, {j, 4})
        pixel(12, {j, 6})
    end for
    -- Draw missiles:
    for j = 1 to missiles*4 by 4 do
        pixel(12,{j, 9})
        pixel(12, {j-1, 10})
        pixel(12, {j+1, 10})
    end for
    -- Erase current weapon:
    Draw_Object(0, current_weapon_shape, {20, 30})
    -- Erase player if alive
    if player[ALIVE] >= 0 then
        if player[ALIVE] <= 1 then
            -- If shields can only take one more hit (from a bullet or
            -- small rock), then change readout display color.
            pixel(repeat(9, player[ALIVE]*10), {1,1})
        else
            -- Otherwise use normal color
            pixel(repeat(11, player[ALIVE]*10), {1,1})
        end if
        Draw_Object(0, player[SHAPE], player[POS])
    end if
    -- Get input
    if player[ALIVE] > 0 then
        -- Regenerate shields a little bit
        player[ALIVE] += (player[MAX_ALIVE]/4)/1000
        if player[ALIVE] > player[MAX_ALIVE] then
            player[ALIVE] = player[MAX_ALIVE]
        end if
        input = get_keys()
        if display_timer < 0 then
            input = {}
        end if
        if find(esc, input) then
            player[ALIVE] = 0
        end if
        if find(right, input) then
            -- Turn right
            player[ANGLE] += 10
            if player[ANGLE] > 360 then
                player[ANGLE] -= 360
            end if
            player[SHAPE] = Rotate(player[SHAPE], rot)
        end if
        if find(left, input) then
            -- Turn left
            player[ANGLE] -= 10
            if player[ANGLE] <= 0 then
                player[ANGLE] += 360
            end if
            player[SHAPE] = Rotate(player[SHAPE], -rot+360)
        end if
        if find(up, input) then
            -- Thrusters
            for i = 1 to 5 do
                temp = player[ANGLE] - 20 + rand(41) + 180
                if temp <= 0 then       temp += 360
                elsif temp > 360 then   temp -= 360
                end if
                Create_Particle(player[POS], temp, rand({6,6})+4, rand(3)+3)
            end for
            -- Normal translation
            player[VELOCITY] += player_accel *
            {cos_lookup[player[ANGLE]], sin_lookup[player[ANGLE]]}

            -- IT WORKS! (Slow player down to top speed)
            temp = sqrt(power(player[VELOCITY][X],2)+power(player[VELOCITY][Y],2))
            if temp > player_top_speed then
                player[VELOCITY] = player[VELOCITY] * player_top_speed / temp
                --This works for sure
                --player[VELOCITY][X] = player[VELOCITY][X] * player_top_speed / temp
                --player[VELOCITY][Y] = player[VELOCITY][Y] * player_top_speed / temp
            end if
        end if
        if find(spacebar, input) then
            --FIRE!!!
            if player[ALIVE] > 0 and player[WEAPON_TIMER]=0 then
                if double_guns then
                    for i = 1 to 3 by 3-double_guns do
                        junk = player[ANGLE] + ((i-2) * 90)
                        if junk <= 0 then junk = junk + 360
                        elsif junk > 360 then junk = junk - 360
                        end if
                        shots = shots & {Setup_Object(FIELDS)}
                        temp = length(shots)
                        shots[temp][TIMER] = player_shot_length

                        -- Uncomment code and replace player[ANGLE] in the
                        -- [VELOCITY][X] line with the comment behind it to have the
                        -- double guns shots converge right as they disappear.
                        -- Pretty cool effect, dunno if I want to keep it
                        -- though. Comments?
                        temp2 = player[ANGLE] - ((i-2)*2)
                        if temp2 <= 0 then temp2 = temp2 + 360
                        elsif temp2 > 360 then temp2 = temp2 - 360
                        end if
                        shots[temp][VELOCITY][X]=shot_speed * cos_lookup[temp2] --player[ANGLE]]
                        shots[temp][VELOCITY][Y]=shot_speed * sin_lookup[temp2] --player[ANGLE]]
    
                        temp2 = shot_speed * cos_lookup[junk]
                        shots[temp][POS][X]=player[POS][X] + temp2 * .75 -- shots[temp][VELOCITY][X]/2
    
                        temp2 = shot_speed * sin_lookup[junk]
                        shots[temp][POS][Y]=player[POS][Y] + temp2 * .75 -- shots[temp][VELOCITY][Y]/2
    
                        shots[temp][COLOR] = 14
                        shots[temp][TAG] = player[TAG]
                        player[WEAPON_TIMER] = player[WEAPON_RATE]
                    end for
                else
                    shots = shots & {Setup_Object(FIELDS)}
                    temp = length(shots)
                    shots[temp][TIMER] = player_shot_length
                    shots[temp][VELOCITY][X]=shot_speed * cos_lookup[player[ANGLE]]
                    shots[temp][VELOCITY][Y]=shot_speed * sin_lookup[player[ANGLE]]
                    shots[temp][POS][X]=player[POS][X] + shots[temp][VELOCITY][X]/2
                    shots[temp][POS][Y]=player[POS][Y] + shots[temp][VELOCITY][Y]/2
                    shots[temp][COLOR] = 14
                    shots[temp][TAG] = player[TAG]
                    player[WEAPON_TIMER] = player[WEAPON_RATE]
                end if
            end if
        end if
        if (find(l_ctrl, input) or find(r_ctrl, input)) then
            -- Nothing
        end if
        if (current_weapon=1 and spreadfire=0) or
           (current_weapon=2 and bombs=0) or
           (current_weapon=3 and missiles=0) then
            input = append(input, r_shift)
        end if
        if (find(l_shift, input) or find(r_shift, input)) and not weapon_switch_timer then
            -- Switch weapons
            while 1 do
                if spreadfire=0 and bombs=0 and missiles=0 then
                    current_weapon=0
                    current_weapon_shape={}
                    exit
                end if
                current_weapon = current_weapon + 1
                if current_weapon > 3 then
                    current_weapon = 1
                end if
                if current_weapon = 1 and spreadfire then
                    current_weapon_shape = {{0,-3},{3,-7},{0,-3},
                     {0,-7},{0,-3},{-3,-7},{0,-3},{-5,5},{5,5}}
                    exit
                end if
                if current_weapon = 2 and bombs then
                    current_weapon_shape = 
                     {{10,0},{-10,0},{0,0},{0,10},{0,-10},{0,0},
                     {5,5},{0,0},{-5,-5},{0,0},{5,-5},{0,0},{-5,5},{0,0}}
                    exit
                end if
                if current_weapon = 3 and missiles then
                    current_weapon_shape = {{4,0},{-4,-2},{0,0},{-4,2}}
                    exit
                end if
            end while
            weapon_switch_timer = weapon_switch_delay
        end if
        if find(l_alt, input) or find(r_alt, input) then --and bombs then
            if player[ALIVE] > 0 and player[WEAPON_TIMER]=0 then
                if current_weapon = 1 then
                    -- Fire spread
                    for i = -10 to 10 by 10 do
                        shots = shots & {Setup_Object(FIELDS)} --Init new shot
                        temp2 = length(shots)
                        shots[temp2][TIMER] = player_shot_length/2
                        temp = player[ANGLE]+i
                        if temp <= 0 then temp = temp + 360
                        elsif temp > 360 then temp = temp - 360 end if
                        shots[temp2][VELOCITY][X]=shot_speed * cos_lookup[temp]
                        shots[temp2][VELOCITY][Y]=shot_speed * sin_lookup[temp]
                        shots[temp2][POS][X]=player[POS][X]+shots[temp2][VELOCITY][X]/2
                        shots[temp2][POS][Y]=player[POS][Y]+shots[temp2][VELOCITY][Y]/2
                        shots[temp2][COLOR] = 14
                        shots[temp2][TAG] = player[TAG]
                        player[WEAPON_TIMER] = player[WEAPON_RATE]
                    end for
                elsif current_weapon = 2 then
                    bomb = bomb & {Setup_Object(FIELDS)}
                    temp = length(bomb)
                    bomb[temp][TIMER] = player_shot_length*.75
                    bomb[temp][VELOCITY][X]=shot_speed * cos_lookup[player[ANGLE]]
                    bomb[temp][VELOCITY][Y]=shot_speed * sin_lookup[player[ANGLE]]
                    bomb[temp][POS][X]=player[POS][X] + bomb[temp][VELOCITY][X]/2
                    bomb[temp][POS][Y]=player[POS][Y] + bomb[temp][VELOCITY][Y]/2
                    bomb[temp][COLOR] = 12
                    bomb[temp][TAG] = player[TAG]
                    player[WEAPON_TIMER] = player[WEAPON_RATE]
                    bombs = bombs - 1
                elsif current_weapon = 3 then
                    --for i = -90 to 90 by 60 do
                        missile = missile & {Setup_Object(FIELDS)} --Init new shot
                        temp2 = length(missile)
                        missile[temp2][TIMER] = player_shot_length * 3 --1.5
                        temp = player[ANGLE] --+i
                        --if temp <= 0 then temp = temp + 360
                        --elsif temp > 360 then temp = temp - 360 end if
                        missile[temp2][VELOCITY][X]=player[VELOCITY][X] + (shot_speed/4) * cos_lookup[temp]
                        missile[temp2][VELOCITY][Y]=player[VELOCITY][Y] + (shot_speed/4) * sin_lookup[temp]
                        missile[temp2][POS][X]=player[POS][X]+missile[temp2][VELOCITY][X] --/2
                        missile[temp2][POS][Y]=player[POS][Y]+missile[temp2][VELOCITY][Y] --/2
                        missile[temp2][COLOR] = 12
                        missile[temp2][SHAPE] = {{2,0},{-2,-2},{0,0},{-2,2}}
                        missile[temp2][ANGLE] = player[ANGLE]
                        missile[temp2][SIZE] = 5
                        missile[temp2][TAG] = player[TAG]
                        
                        player[WEAPON_TIMER] = player[WEAPON_RATE]
    
                        temp = missile[temp2][SHAPE]
                        for j = 1 to length(missile[temp2][SHAPE]) do
                            temp[j][1] = missile[temp2][SHAPE][j][1] *
                             cos_lookup[player[ANGLE]]-missile[temp2][SHAPE][j][2] * sin_lookup[player[ANGLE]]
                            temp[j][2] = missile[temp2][SHAPE][j][2] *
                             cos_lookup[player[ANGLE]]+missile[temp2][SHAPE][j][1] * sin_lookup[player[ANGLE]]
                        end for
                        missile[temp2][SHAPE] = temp
                    --end for
                    missiles = missiles - 1
                end if
            end if
        end if
        
        -- Rotate weapon display (eye candy)
        current_weapon_shape = Rotate(current_weapon_shape, -5+360)
        
        Draw_Object(12, current_weapon_shape, {20, 30})
        if weapon_switch_timer > 0 then
            weapon_switch_timer = weapon_switch_timer - 1
        end if

        --Update and draw player
        if player[WEAPON_TIMER] > 0 then
            player[WEAPON_TIMER] = player[WEAPON_TIMER] - 1
        end if
        if player[ANGLE] = 270 then
            player[SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
        end if
        player[POS] += player[VELOCITY]
        player[POS] = Wrap(player[POS])
        Draw_Object(player[COLOR], player[SHAPE], player[POS])
    else
        if player[ALIVE] = 0 then
            for k = 1 to 150 do
                Create_Particle(player[POS], rand(360), rand({10,10}), rand(10)+10)
            end for
            player[ALIVE] = -1
            -- Check to see if player made high score list
            for j = 1 to 10 do
                if score > scores[j][SCORE] then
                    -- He/she did! Set high_score flag to correct slot
                    high_score = j
                    for k = 10 to j+1 by -1 do
                        scores[k] = scores[k-1]
                    end for
                    scores[j][NAME] = ""
                    scores[j][SCORE] = score
                    scores[j][LEVEL] = level
                    exit
                end if
            end for
        end if
    end if
end procedure

procedure update_sats()             -- Update the satellites
    integer i
    i = 0
    while i < length(sats) do
        i = i + 1
        Draw_Object(0, sats[i][SHAPE], sats[i][POS])
        sats[i][POS] += sats[i][VELOCITY]
        if sats[i][ALIVE] then
            sats[i][SHAPE] = Rotate(sats[i][SHAPE], sats[i][ROTATION])
            sats[i][POS] = Wrap(sats[i][POS])
            Draw_Object(sats[i][COLOR], sats[i][SHAPE], sats[i][POS])
            -- Fire??
            if rand(40) = 1 then
                -- A bit too effective. :-)
                -- temp = floor(To_Target(sats[i][POS], player[POS], player[VELOCITY]))
                temp = rand(360)
                for j = length(shots)+1 to length(shots)+3 do
                    shots = shots & {Setup_Object(FIELDS)}
                    shots[j][TIMER] = sat_shot_length
                    temp = temp + 120
                    if temp > 360 then temp = temp - 360 end if
                    shots[j][VELOCITY][X]=shot_speed * cos_lookup[temp]
                    shots[j][VELOCITY][Y]=shot_speed * sin_lookup[temp]
                    shots[j][POS][X]=sats[i][POS][X]+shots[length(shots)][VELOCITY][X]/2
                    shots[j][POS][Y]=sats[i][POS][Y]+shots[length(shots)][VELOCITY][Y]/2
                    shots[j][COLOR] = 13
                    shots[j][TAG] = -1
                end for
            end if
            if player[ALIVE] > 0 then
                --Player hit by sat?
                if Collide(sats[i][POS], player[POS], sats[i][SIZE]) then
                    player[ALIVE] = player[ALIVE] - 2
                    if player[ALIVE] < 0 then
                        player[ALIVE] = 0
                    end if

                    -- This seems to work for bouncing the ship around:
                    --if player[VELOCITY][Y] = 0 then player[VELOCITY][Y] = 0.000000001 end if
                    --temp = arctan(player[VELOCITY][X] / player[VELOCITY][Y])
                    --temp = floor(temp * 2 * PI)
                    --if rand(2) = 1 then
                    --    temp = temp + 45
                    --    if temp > 360 then temp = temp - 360 end if
                    --else
                    --    temp = temp - 45
                    --    if temp <= 0 then temp = temp + 360 end if
                    --end if
                    --temp2 = sqrt(power(player[VELOCITY][X],2)+power(player[VELOCITY][Y],2))
                    --player[VELOCITY][X] = temp2 * cos_lookup[temp]
                    --player[VELOCITY][Y] = temp2 * sin_lookup[temp]

                    sats[i][ALIVE] = 0
                end if
            end if
        else
            for k = 1 to 75 do
                Create_Particle(sats[i][POS], rand(360), rand({10,10}), rand(8)+2)
            end for
            if rand(3) = 1 then
                powerups = powerups & {Setup_Object(FIELDS)}
                temp = length(powerups)
                powerups[temp][TAG] = rand(6)
                if powerups[temp][TAG] = 1 then     -- Spreadfire
                    --powerups[temp][SHAPE] = 
                    -- {{10,10},{5,0},{10,10},{0,0},{10,10},{0,5}}
                    powerups[temp][SHAPE] = {{0,-3},{3,-7},{0,-3},
                    {0,-7},{0,-3},{-3,-7},{0,-3},{-5,5},{5,5}}
                elsif powerups[temp][TAG] = 2 then  -- Extra bomb
                    powerups[temp][SHAPE] = 
                     {{10,0},{-10,0},{0,0},{0,10},{0,-10},{0,0},
                      {5,5},{0,0},{-5,-5},{0,0},{5,-5},{0,0},{-5,5},{0,0}}
                elsif powerups[temp][TAG] = 3 then  -- Rapid fire
                    powerups[temp][SHAPE] = {{0,-5},{0,0},{0,-5},
                    {-5,5},{0,5},{0,3},{0,5},{5,5}}
                elsif powerups[temp][TAG] = 4 then  -- Missiles
                    powerups[temp][SHAPE] = {{4,0},{-4,-2},{0,0},{-4,2}}
                elsif powerups[temp][TAG] = 5 then  -- Double guns
                    powerups[temp][SHAPE] = {{5,0},{5,5},{5,0},
                                            {-5,0},{-5,5},{-5,0},
                                            {0,10}}
                elsif powerups[temp][TAG] = 6 then  -- More shields
                    powerups[temp][SHAPE] = {{-4,-6},{-4,2},{0,6},{4,2},{4,-6},{-3,3},{4,-6}}
                end if
                powerups[temp][SIZE] = 10
                powerups[temp][POS][X] = sats[i][POS][X]
                powerups[temp][POS][Y] = sats[i][POS][Y]
                temp2 = rand(360)
                powerups[temp][VELOCITY][X] = rand(3) * cos_lookup[temp2]
                powerups[temp][VELOCITY][Y] = rand(3) * sin_lookup[temp2]
                powerups[temp][ROTATION] = rand(20)-10
                if powerups[temp][ROTATION] <= 0 then
                    powerups[temp][ROTATION] =
                     powerups[temp][ROTATION] + 359
                end if
                powerups[temp][COLOR] = 13
                powerups[temp][TIMER] = 300
            end if
            sats = sats[1..i-1] & sats[i+1..length(sats)]
            i = i - 1
        end if
    end while
end procedure

procedure update_enemies()          -- Update all AI enemies
    -- Be sure to take a quick look at this code. The AI code was created
    -- in just one day, and it was my FIRST EVER attempt at AI! The next
    -- couple days consisted of 2 or 3 tweaks to make it less agressive and
    -- figure out the best way to have the enemies appear on screen. (Before,
    -- they never appeared at the start of the level, but came later during
    -- the level, more often on later levels. Playtesting told me which was
    -- better.) I have just added the distance modifier however. This makes
    -- the AI get more aggressive at close distance
    integer i, to_dir
    atom distance -- Distance from player
    i = 0
    if rand(1000) = 1 then
        if display_timer >= 0 then
            enemy = enemy & {Setup_Object(FIELDS)}
            temp = length(enemy)
            enemy[temp][POS][X] = rand(2)
            enemy[temp][POS][Y] = rand(2)
            if enemy[temp][POS][X]=2 then enemy[temp][POS][X]=video_type[VC_XPIXELS] end if
            if enemy[temp][POS][Y]=2 then enemy[temp][POS][Y]=video_type[VC_YPIXELS] end if
            enemy[temp][VELOCITY][X]= 0 enemy[temp][VELOCITY][Y]= 0
            enemy[temp][ALIVE] = 2
            enemy[temp][MAX_ALIVE]=2
            enemy[temp][SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
            enemy[temp][COLOR] = 12
            enemy[temp][SIZE] = 6
            enemy[temp][ANGLE] = 270
            enemy[temp][TAG] = 2
            enemy[temp][WEAPON_RATE] = 6
            enemy[temp][WEAPON_TIMER] = 0
            enemy[temp][AI_CLASS] = rand(3)
            if enemy[temp][AI_CLASS]=3 then
                enemy[temp][AI_CLASS]=rand(2)+1
            end if
            if enemy[temp][AI_CLASS] > level then
                enemy[temp][AI_CLASS] = 1
            end if
            if enemy[temp][AI_CLASS]=3 then
                enemy[temp][COLOR]-=8
            end if
        end if
    end if
    while i < length(enemy) do
        i = i + 1
        --Erase ship
        if enemy[i][ALIVE] >= 0 then
            Draw_Object(0, enemy[i][SHAPE], enemy[i][POS])
        end if
        if enemy[i][ALIVE] > 0 then
            -- Hey, let's allow the enemies to recharge their shields also...
            enemy[i][ALIVE] += .001
            if enemy[i][ALIVE] > enemy[i][MAX_ALIVE] then
                enemy[i][ALIVE] = enemy[i][MAX_ALIVE]
            end if
            -- Decide which direction the enemy wants to face based on
            -- AI class
            to_dir = 360
            if enemy[i][AI_CLASS] = 1 then -- Rookie
                to_dir = floor(Angle(enemy[i][POS], player[POS]))
            elsif enemy[i][AI_CLASS] = 2 then -- Veteran
                if player[POS][X] < enemy[i][POS][X] - 30 then    -- Player on left?
                    to_dir = to_dir + 180               -- Try other direction
                    if player[POS][Y] < enemy[i][POS][Y] - 30 then    -- If not within 30
                        to_dir = to_dir + 45                -- pixels, face
                    elsif player[POS][Y] > enemy[i][POS][Y] + 30 then -- diagonally, else
                        to_dir = to_dir - 45                -- face side.
                    end if
                elsif player[POS][X] > enemy[i][POS][X] + 30 then -- Player is on right?
                    to_dir = to_dir                     -- Keep same direction
                    if player[POS][Y] < enemy[i][POS][Y] - 30 then
                        to_dir = to_dir - 45
                    elsif player[POS][Y] > enemy[i][POS][Y] + 30 then
                        to_dir = to_dir + 45
                    end if
                elsif player[POS][Y] < enemy[i][POS][Y] then      -- Face up or down?
                    to_dir = to_dir - 90
                elsif player[POS][Y] > enemy[i][POS][Y] then
                    to_dir = to_dir + 90
                end if
            elsif enemy[i][AI_CLASS] = 3 then -- Ace
                to_dir = floor(To_Target(enemy[i][POS], player[POS], player[VELOCITY]))
            end if
            -- Get value between 1 and 360
            if to_dir > 360 then to_dir = to_dir - 360
            elsif to_dir <= 0 then to_dir = to_dir + 360 end if
            -- Now we have the direction we want the enemy to face, check
            -- to see if he is already facing where we want:
            if to_dir < enemy[i][ANGLE]-9 or to_dir > enemy[i][ANGLE]+9 then
                -- Need to turn. Figure out which direction is the quickest
                -- way to turn and get the correct direction.
                to_dir = to_dir - enemy[i][ANGLE]
                if to_dir <= 0 then to_dir = to_dir + 360 end if
                if to_dir <= -to_dir + 360 then
                    --Turn right
                    enemy[i][ANGLE] += 10
                    if enemy[i][ANGLE] > 360 then
                        enemy[i][ANGLE] -= 360
                    end if
                    enemy[i][SHAPE] = Rotate(enemy[i][SHAPE], rot)
                else
                    --Turn left
                    enemy[i][ANGLE] -= 10
                    if enemy[i][ANGLE] <= 0 then
                        enemy[i][ANGLE] += 360
                    end if
                    enemy[i][SHAPE] = Rotate(enemy[i][SHAPE], -rot+360)
                end if
            end if
            distance = Distance(player[POS], enemy[i][POS])
            if distance <= 200 then -- In range?
                distance = 1        -- In range
            else
                distance = 0        -- Not in range
            end if
            if rand(20) = 1 or (distance and rand(2)=1) then
                -- He decides he needs a little thrust...
                for j = 1 to 3 do
                    temp = enemy[i][ANGLE] - 20 + rand(41) + 180
                    if temp <= 0 then       temp += 360
                    elsif temp > 360 then   temp -= 360
                    end if
                    Create_Particle(enemy[i][POS], temp, rand({6,6})+4, rand(3)+3)
                end for
                -- Normal translation
                enemy[i][VELOCITY][X]=enemy[i][VELOCITY][X]+(player_accel * cos_lookup[enemy[i][ANGLE]])
                enemy[i][VELOCITY][Y]=enemy[i][VELOCITY][Y]+(player_accel * sin_lookup[enemy[i][ANGLE]])
                temp = sqrt(power(enemy[i][VELOCITY][X],2)+power(enemy[i][VELOCITY][Y],2))
                if temp > player_top_speed then
                    enemy[i][VELOCITY][X] = enemy[i][VELOCITY][X] * player_top_speed / temp
                    enemy[i][VELOCITY][Y] = enemy[i][VELOCITY][Y] * player_top_speed / temp
                end if
            end if
            if rand(20) = 1 or (distance and rand(10)=1) then
            -- Fire, maybe it'll be a hit? :)
                if enemy[i][WEAPON_TIMER] = 0 and enemy[i][ALIVE] > 0 then
                    shots = shots & {Setup_Object(FIELDS)}
                    temp = length(shots)
                    shots[temp][TIMER] = sat_shot_length
                    shots[temp][VELOCITY][X]=shot_speed * cos_lookup[enemy[i][ANGLE]]
                    shots[temp][VELOCITY][Y]=shot_speed * sin_lookup[enemy[i][ANGLE]]
                    shots[temp][POS][X]=enemy[i][POS][X] + shots[temp][VELOCITY][X]/2
                    shots[temp][POS][Y]=enemy[i][POS][Y] + shots[temp][VELOCITY][Y]/2
                    shots[temp][COLOR] = 13
                    shots[temp][TAG] = enemy[i][TAG]
                    enemy[i][WEAPON_TIMER] = enemy[i][WEAPON_RATE]
                end if
            end if
            --Update and draw enemy.
            if enemy[i][WEAPON_TIMER] > 0 then
                enemy[i][WEAPON_TIMER] -= 1
            end if
            if enemy[i][ANGLE] = 270 then
                enemy[i][SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
            end if
            enemy[i][POS] += enemy[i][VELOCITY]
            enemy[i][POS] = Wrap(enemy[i][POS])
            Draw_Object(enemy[i][COLOR], enemy[i][SHAPE], enemy[i][POS])
            if player[ALIVE] > 0 then
                -- Player collide with enemy?
                if Collide(enemy[i][POS], player[POS], enemy[i][SIZE]) then
                    player[ALIVE] -= 2
                    if player[ALIVE] < 0 then
                        player[ALIVE] = 0
                    end if

                    -- This seems to work for bouncing the ship around:
                    --if player[VELOCITY][Y] = 0 then player[VELOCITY][Y] = 0.000000001 end if
                    --temp = arctan(player[VELOCITY][X] / player[VELOCITY][Y])
                    --temp = floor(temp * 2 * PI)
                    --if rand(2) = 1 then
                    --    temp = temp + 45
                    --   if temp > 360 then temp = temp - 360 end if
                    --else
                    --   temp = temp - 45
                    --    if temp <= 0 then temp = temp + 360 end if
                    --end if
                    --temp2 = sqrt(power(player[VELOCITY][X],2)+power(player[VELOCITY][Y],2))
                    --player[VELOCITY][X] = temp2 * cos_lookup[temp]
                    --player[VELOCITY][Y] = temp2 * sin_lookup[temp]

                    enemy[i][ALIVE] -= 2
                    if enemy[i][ALIVE] < 0 then
                        enemy[i][ALIVE] = 0
                    end if
                end if
            end if
        else
            if enemy[i][ALIVE] = 0 then
                for k = 1 to 50 do
                    Create_Particle(enemy[i][POS], rand(360), rand({10,10}), rand(10)+5)
                end for
                enemy = enemy[1..i-1] & enemy[i+1..length(enemy)]
                i = i - 1
            end if
        end if
    end while
end procedure

procedure update_rocks()            -- Update all the asteroids
    integer i
    i = 0
    while i < length(rocks) do
        i = i + 1
        Draw_Object(0, rocks[i][SHAPE], rocks[i][POS])
        if rocks[i][ALIVE] > 0 then
            rocks[i][POS] += rocks[i][VELOCITY]
            rocks[i][SHAPE] = Rotate(rocks[i][SHAPE], rocks[i][ROTATION])
            rocks[i][POS] = Wrap(rocks[i][POS])
            Draw_Object(rocks[i][COLOR], rocks[i][SHAPE], rocks[i][POS])
            if player[ALIVE] > 0 then
                -- Player hit by rock?
                if Collide(rocks[i][POS], player[POS], rocks[i][SIZE]) then
                    player[ALIVE] -= rocks[i][SIZE]/10
                    if player[ALIVE] < 0 then
                        player[ALIVE] = 0
                    end if

                    -- This seems to work for bouncing the ship around:
                    -- Now I just need to make sure that you always bounce
                    -- AWAY from the rock you just ran into. Don't know
                    -- quite how to do that, but the Descent source code
                    -- physics stuff could help. Hopefully.

                    --if player[VELOCITY][Y] = 0 then player[VELOCITY][Y] = 0.000000001 end if
                    --temp = abs(arctan(player[VELOCITY][X] / player[VELOCITY][Y]))
                    --temp = floor(temp / PI * 180)
                    --temp = temp - 90
                    --if player[VELOCITY][X] < 0 then
                    --    temp = temp + 180
                    --end if
                    --if rand(2) = 1 then
                    --    temp = temp + 20
                    --else
                    --    temp = temp - 20
                    --end if
                    --temp2 = sqrt(power(player[VELOCITY][X],2)+power(player[VELOCITY][Y],2))
                    --player[VELOCITY][X] = temp2 * cos(temp)
                    --player[VELOCITY][Y] = temp2 * sin(temp)

                    rocks[i][ALIVE] = 0
                end if
            end if
            -- Enemy fighter hit by rock?
            for j = 1 to length(enemy) do
                if Collide(rocks[i][POS], enemy[j][POS], rocks[i][SIZE]) then
                    enemy[j][ALIVE] -= rocks[i][SIZE]/10
                    if enemy[j][ALIVE] < 0 then
                        enemy[j][ALIVE] = 0
                    end if
                    rocks[i][ALIVE] = 0
                end if
            end for
        else
            for k = 1 to 40 do
                Create_Particle(rocks[i][POS], rand(360), rand({10,10}), rand(8)+2)
            end for
            if rocks[i][SIZE] > 10 then
                for j = 1 to rand(2) + 1 do
                    temp2 = (rocks[i][SIZE]/10)-1
                    rocks = rocks & {Setup_Object(FIELDS)}
                    temp = length(rocks)
                    rocks[temp][SHAPE] =
                    ({{10,10},{10,0},{10,-10},{0,-10},{-10,-10},{-10,0},
                     {-10,10},{0,10}} - 5)
                    for k = 1 to 8 do
                        rocks[temp][SHAPE][k][1] =
                         (rocks[temp][SHAPE][k][1] + rand(10))*temp2
                        rocks[temp][SHAPE][k][2] =
                         (rocks[temp][SHAPE][k][2] + rand(10))*temp2
                    end for
                    rocks[temp][SIZE] = 10 * temp2
                    rocks[temp][POS][X] = rocks[i][POS][X]
                    rocks[temp][POS][Y] = rocks[i][POS][Y]
                    temp2 = rand(360)
                    -- Throw rocks in about the same direction
                    rocks[temp][VELOCITY][X]=rocks[i][VELOCITY][X]+(rand(3)*cos_lookup[temp2])
                    rocks[temp][VELOCITY][Y]=rocks[i][VELOCITY][Y]+(rand(3)*sin_lookup[temp2])
                    rocks[temp][ROTATION] = rand(30)-15
                    if rocks[temp][ROTATION] <= 0 then
                        rocks[temp][ROTATION] = rocks[temp][ROTATION]+359
                    end if
                    rocks[temp][COLOR] = rocks[i][COLOR]
                    rocks[temp][ALIVE] = 1
                end for
            end if
            rocks = rocks[1..i-1] & rocks[i+1..length(rocks)]
            i = i - 1
        end if
    end while
end procedure

procedure update_bombs()            -- Update bombs in universe
    integer i, last_score
    atom distance
    
    i = 0
    last_score = score
    while i < length(bomb) do
        i = i + 1
        --Erase the bombs
        pixel({0,0,0}, {bomb[i][POS][X]-1, bomb[i][POS][Y]})
        pixel(0, {bomb[i][POS][X], bomb[i][POS][Y]+1})
        pixel(0, {bomb[i][POS][X], bomb[i][POS][Y]-1})
        bomb[i][TIMER] -= 1
        if bomb[i][TIMER] then
            bomb[i][POS] += bomb[i][VELOCITY]
            bomb[i][POS] = Wrap(bomb[i][POS])
            pixel({bomb[i][COLOR],bomb[i][COLOR],bomb[i][COLOR]},
              {bomb[i][POS][X]-1, bomb[i][POS][Y]}) --draw
            pixel(bomb[i][COLOR], {bomb[i][POS][X], bomb[i][POS][Y]+1})
            pixel(bomb[i][COLOR], {bomb[i][POS][X], bomb[i][POS][Y]-1})       
        else
            -- Explode!
            for j = length(shots)+1 to length(shots)+36 do
                shots = shots & {Setup_Object(FIELDS)}
                shots[j][TIMER] = (rand(7)+(player_shot_length/3)-4)
                temp2 = rand(360)
                shots[j][VELOCITY][X]=(rand(7)+shot_speed-4) * cos_lookup[temp2]
                shots[j][VELOCITY][Y]=(rand(7)+shot_speed-4) * sin_lookup[temp2]
                shots[j][POS][X]=bomb[i][POS][X]+shots[length(shots)][VELOCITY][X]/2
                shots[j][POS][Y]=bomb[i][POS][Y]+shots[length(shots)][VELOCITY][Y]/2
                shots[j][COLOR] = 11+rand(3)
                shots[j][TAG] = bomb[i][TAG]
            end for

            --distance = Distance(bomb[i][POS], [POS])
            --[ALIVE] = [ALIVE] - (-distance+30)/10)

            -- Test proximity to explosion and damage objects.
            -- (May not work perfectly yet, but it still works good enough,
            -- for now, at least.)
            if player[ALIVE] > 0 then    --Player
                distance = Distance(bomb[i][POS], player[POS])
                if distance < 100 then
                    player[ALIVE] = player[ALIVE] - ((-distance+100)/33)
                    if player[ALIVE] < 0 then
                        player[ALIVE] = 0
                    end if
                end if
            end if
            --With rocks
            for j = 1 to length(rocks) do
                if rocks[j][ALIVE] > 0 then
                    distance = Distance(bomb[i][POS], rocks[j][POS])
                    if distance < 100 then
                        rocks[j][ALIVE] = 0
                        if bomb[i][TAG] = player[TAG] then
                            score = score + ((-rocks[j][SIZE]/10)+4)*10
                        end if
                    end if
                end if
            end for
            -- With enemies
            for j = 1 to length(enemy) do
                if enemy[j][ALIVE] > 0 then
                    distance = Distance(bomb[i][POS], enemy[j][POS])
                    if distance < 100 then
                        enemy[j][ALIVE] = enemy[j][ALIVE] - ((-distance+100)/33)
                        if enemy[j][ALIVE] < 0 then
                            enemy[j][ALIVE] = 0
                            if bomb[i][TAG] = player[TAG] then
                                score += 40 + (enemy[j][AI_CLASS]*10)
                            end if
                        end if
                    end if
                end if
            end for
            -- With satelites
            for j = 1 to length(sats) do
                if sats[j][ALIVE] > 0 then
                    distance = Distance(bomb[i][POS], sats[j][POS])
                    if distance < 100 then
                        sats[j][ALIVE] = 0
                        if bomb[i][TAG] = player[TAG] then
                            score = score + 40
                        end if
                    end if
                end if
            end for

            bomb = bomb[1..i-1] & bomb[i+1..length(bomb)]
            i = i - 1
        end if
    end while
    if score > last_score then
        if display_timer then
            VFcenter(26, sprintf("Score %d", {last_score}), 0)
        end if
        if player[ALIVE] < 0 then
            score = last_score
        end if
    end if
end procedure

procedure update_missiles()
    integer i, last_score, to_dir, dist, c, c_dist, target
    last_score = score
    i = 0
    while i < length(missile) do
        i = i + 1
        -- Erase missile
        if missile[i][ALIVE] >= 0 then
            Draw_Object(0, missile[i][SHAPE], missile[i][POS])
        end if
        c = 0
        c_dist = 9999999 -- Far enough? ;-)
        target=0
        for j = 1 to length(enemy) do
            if Can_See(missile[i][POS], enemy[j][POS], missile[i][ANGLE], 90) then
                dist = floor(Distance(missile[i][POS], enemy[j][POS]))
                if dist < c_dist then
                    c_dist = dist
                    c = j
                    target=1
                end if
            end if
        end for
        if not c then -- No enemies? Go for sats instead.
            for j = 1 to length(sats) do
                if Can_See(missile[i][POS], sats[j][POS], missile[i][ANGLE], 90) then
                    dist = floor(Distance(missile[i][POS], sats[j][POS]))
                    if dist < c_dist then
                        c_dist = dist
                        c = j
                        target=2
                    end if
                end if
            end for
        end if
        if missile[i][ALIVE] > 0 then
            missile[i][TIMER] -= 1
            if target=1 then
                to_dir = floor(Angle(missile[i][POS], enemy[c][POS]))
            elsif target=2 then
                to_dir = floor(Angle(missile[i][POS], sats[c][POS]))
            else to_dir = missile[i][ANGLE] end if
            if to_dir < missile[i][ANGLE]-4 or to_dir > missile[i][ANGLE]+4 then
                to_dir = to_dir - missile[i][ANGLE]
                if to_dir <= 0 then to_dir = to_dir + 360 end if
                if to_dir <= -to_dir + 360 then
                    --Turn right
                    missile[i][ANGLE] += 5
                    if missile[i][ANGLE] > 360 then
                        missile[i][ANGLE] -= 360
                    end if
                    missile[i][SHAPE] = Rotate(missile[i][SHAPE], 5)
                else
                    --Turn left
                    missile[i][ANGLE] -= 5
                    if missile[i][ANGLE] <= 0 then
                        missile[i][ANGLE] += 360
                    end if
                    missile[i][SHAPE] = Rotate(missile[i][SHAPE], -5+360)
                end if
            end if
            -- Do thrusters
            if rand(3) = 1 then
                temp = missile[i][ANGLE] - 20 + rand(41) + 180
                if temp <= 0 then       temp += 360
                elsif temp > 360 then   temp -= 360
                end if
                Create_Particle(missile[i][POS], temp, rand({6,6})+4, rand(3)+3)
            end if
            -- Normal translation
            missile[i][VELOCITY][X]=shot_speed * cos_lookup[missile[i][ANGLE]]
            missile[i][VELOCITY][Y]=shot_speed * sin_lookup[missile[i][ANGLE]]
            --missile[i][VELOCITY][X]=missile[i][VELOCITY][X]+(player_accel * cos_lookup[missile[i][ANGLE]]*2)
            --missile[i][VELOCITY][Y]=missile[i][VELOCITY][Y]+(player_accel * sin_lookup[missile[i][ANGLE]]*2)
            --temp = sqrt(power(missile[i][VELOCITY][X],2)+power(missile[i][VELOCITY][Y],2))
            --if temp > shot_speed then
            --    missile[i][VELOCITY][X] = missile[i][VELOCITY][X] * shot_speed / temp
            --    missile[i][VELOCITY][Y] = missile[i][VELOCITY][Y] * shot_speed / temp
            --end if
            -- Update and draw missile.
            missile[i][POS] += missile[i][VELOCITY]
            missile[i][POS] = Wrap(missile[i][POS])
            Draw_Object(missile[i][COLOR],missile[i][SHAPE],missile[i][POS])
            if missile[i][TIMER] < (player_shot_length*3)-2 then
                if player[ALIVE] > 0 then
                    -- Player collide with missile?
                    if Collide(missile[i][POS], player[POS], player[SIZE]+3) then
                        player[ALIVE] = player[ALIVE] - 2
                        if player[ALIVE] < 0 then
                            player[ALIVE] = 0
                        end if
                        missile[i][ALIVE] = 0
                    end if
                end if
                -- Check with collisions for other things:
                for j = 1 to length(rocks) do
                    -- Rock collide with missile?
                    if Collide(missile[i][POS], rocks[j][POS], rocks[j][SIZE]+3) then
                        rocks[j][ALIVE] = rocks[j][ALIVE] - 2
                        if rocks[j][ALIVE] < 0 then
                            rocks[j][ALIVE] = 0
                        end if
                        if missile[i][TAG] = player[TAG] then
                            score = score + ((-rocks[j][SIZE]/10)+4)*10
                        end if
                        missile[i][ALIVE] = 0
                    end if
                end for
                for j = 1 to length(sats) do
                    -- Sat collide with missile?
                    if Collide(missile[i][POS], sats[j][POS], sats[j][SIZE]+3) then
                        sats[j][ALIVE] = sats[j][ALIVE] - 2
                        if sats[j][ALIVE] < 0 then
                            sats[j][ALIVE] = 0
                        end if
                        if missile[i][TAG] = player[TAG] then
                            score = score + 40
                        end if
                        missile[i][ALIVE] = 0
                    end if
                end for
                for j = 1 to length(enemy) do
                    -- Enemy collide with missile?
                    if Collide(missile[i][POS], enemy[j][POS], enemy[j][SIZE]+3) then
                        enemy[j][ALIVE] = enemy[j][ALIVE] - 2
                        if enemy[j][ALIVE] < 0 then
                            enemy[j][ALIVE] = 0
                        end if
                        if missile[i][TAG] = player[TAG] then
                            score += 40 + (enemy[j][AI_CLASS]*10)
                        end if
                        missile[i][ALIVE] = 0
                    end if
                end for
            end if
        else
            if missile[i][ALIVE] = 0 then
                for k = 1 to 5 do
                    Create_Particle(missile[i][POS], rand(360), rand({10,10}), rand(10)+5)
                end for
                missile = missile[1..i-1] & missile[i+1..length(missile)]
                i = i - 1
            end if
        end if
    end while
    if score > last_score then
        if display_timer then
            VFcenter(26, sprintf("Score %d", {last_score}), 0)
        end if
        if player[ALIVE] < 0 then
            score = last_score
        end if
    end if
end procedure

procedure update_shots()            -- Update player & enemy shots
    sequence shot
    integer i, last_score
    last_score = score
    i = 0
    while i < length(shots) do
        i += 1
        shot = shots[i]
        pixel(repeat(0, 3), {shot[POS][X]-1, shot[POS][Y]}) -- Erase
        pixel(0, {shot[POS][X], shot[POS][Y]+1})
        pixel(0, {shot[POS][X], shot[POS][Y]-1})
        shot[TIMER] -= 1
        if shot[TIMER] > 0 then
            shot[POS] += shot[VELOCITY]
            shot[POS] = Wrap(shot[POS])
            pixel(repeat(shot[COLOR], 3), {shot[POS][X]-1, shot[POS][Y]})
            pixel(shot[COLOR], {shot[POS][X], shot[POS][Y]+1})
            pixel(shot[COLOR], {shot[POS][X], shot[POS][Y]-1})
            -- Test for collisions
            if player[ALIVE] > 0 then    -- Player
                if Collide(shot[POS], player[POS], player[SIZE]) then
                    shot[TIMER] = 0
                    player[ALIVE] -= 1
                    if player[ALIVE] < 0 then
                        player[ALIVE] = 0
                    else
                        for k = 1 to 20 do
                            -- Small explosion (So player knows he has been
                            -- hit.)
                            Create_Particle(player[POS], rand(360), rand({10,10}), rand(4)+4)
                        end for
                    end if
                end if
            end if
            --With rocks
            for j = 1 to length(rocks) do
                if rocks[j][ALIVE] > 0 then
                    if Collide(shot[POS], rocks[j][POS], rocks[j][SIZE]) then
                        shot[TIMER] = 0
                        rocks[j][ALIVE] = 0
                        if shot[TAG] = player[TAG] then
                            score += ((-rocks[j][SIZE]/10)+4)*10
                        end if
                    end if
                end if
            end for
            -- With enemies
            for j = 1 to length(enemy) do
                if Collide(shot[POS], enemy[j][POS], enemy[j][SIZE]) then
                    shot[TIMER] = 0
                    enemy[j][ALIVE] -= 1
                    if enemy[j][ALIVE] < 0 then
                        enemy[j][ALIVE] = 0
                        if shot[TAG] = player[TAG] then
                            score += 40 + (enemy[j][AI_CLASS]*10)
                        end if
                    else
                        for k = 1 to 20 do
                            -- Small explosion (So player knows the enemy has
                            -- been hit.)
                            Create_Particle(enemy[j][POS], rand(360), rand({10,10}), rand(4)+4)
                        end for
                    end if
                end if
            end for
            -- With satelites
            for j = 1 to length(sats) do
                if sats[j][ALIVE] > 0 then
                    if Collide(shot[POS], sats[j][POS], sats[j][SIZE]) then
                        shot[TIMER] = 0
                        sats[j][ALIVE] = 0
                        if shot[TAG] = player[TAG] then
                            score += 40
                        end if
                    end if
                end if
            end for
            shots[i] = shot
        else
            shots=shots[1..i-1] & shots[i+1..length(shots)]
            i = i - 1
        end if
    end while
    if score > last_score then
        if display_timer then
            VFcenter(26, sprintf("Score %d", {last_score}), 0)
        end if
        if player[ALIVE] < 0 then
            score = last_score
        end if
    end if
end procedure

procedure update_powerups()         -- Update all powerups
    atom i
    i = 0
    while i < length(powerups) do
        i = i + 1
        Draw_Object(0, powerups[i][SHAPE], powerups[i][POS])
        powerups[i][POS] += powerups[i][VELOCITY]
        powerups[i][TIMER] = powerups[i][TIMER] - 1
        if powerups[i][TIMER] > 0 then
            powerups[i][SHAPE] = Rotate(powerups[i][SHAPE], powerups[i][ROTATION])
            -- Wrap powerups
            powerups[i][POS] = Wrap(powerups[i][POS])
            -- Draw powerups
            Draw_Object(powerups[i][COLOR], powerups[i][SHAPE], powerups[i][POS])
            if player[ALIVE] > 0 then
                if Collide(powerups[i][POS], player[POS], powerups[i][SIZE]) then
                    -- Give player a reward...
                    if powerups[i][TAG] = 1 then        -- Spreadfire
                        spreadfire = spreadfire + 1
                    elsif powerups[i][TAG] = 2 then     -- Extra bomb
                        bombs = bombs + 1
                    elsif powerups[i][TAG] = 3 then     -- Rapid fire
                        player[WEAPON_RATE] = player[WEAPON_RATE] - 2
                        if player[WEAPON_RATE] < 4 then
                            player[WEAPON_RATE] = 4
                        end if
                    elsif powerups[i][TAG] = 4 then     -- Homing missiles
                        missiles = missiles + 2
                    elsif powerups[i][TAG] = 5 then     -- Double guns
                        double_guns = double_guns + 1
                        if double_guns > 1 then
                            double_guns = 1
                        end if
                    elsif powerups[i][TAG] = 6 then
                        player[MAX_ALIVE] += 1
                        player[ALIVE] += 2
                        if player[ALIVE] > player[MAX_ALIVE] then
                            player[ALIVE] = player[MAX_ALIVE]
                        end if
                    end if
                    powerups[i][TIMER] = 0
                end if
            end if
        else
            powerups = powerups[1..i-1] & powerups[i+1..length(powerups)]
            i = i - 1
        end if
    end while
end procedure

procedure update_particles()        -- Update all particle explosions
    sequence particle
    integer i
    i = 0
    while i < length(particles) do
        i += 1
        particle = particles[i]
        pixel(0, particle[POS])
        particle[TIMER] -= 1
        if particle[TIMER] > 0 then
            particle[POS] += particle[VELOCITY]
            particle[POS] = Wrap(particle[POS])
            pixel(particle[COLOR], particle[POS])
            particles[i] = particle
        else
            particles = particles[1..i-1] & particles[i+1..length(particles)]
            i -= 1
        end if
    end while
end procedure

procedure play_game()               -- Main routine
--Setup variables
player={} rocks={} shots={} particles={} sats={} powerups={} bomb = {}
enemy={} missile={}
input = {}
quit = 0 level = 0 display_timer = 0 score = 0 high_score = 0

--Setup player
player = Setup_Object(FIELDS)
player[POS][X] = video_type[VC_XPIXELS]/2
player[POS][Y] = video_type[VC_YPIXELS]/2
player[VELOCITY][X]= 0 player[VELOCITY][Y]= 0
player[ALIVE] = 4
player[MAX_ALIVE]=4
player[SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
player[COLOR] = 11
player[SIZE] = 6
player[ANGLE] = 270
player[TAG] = 1
player[WEAPON_RATE] = 8
player[WEAPON_TIMER] = 0
if level = 0 then
    player[ALIVE] = -1
end if
player_shot_length = 20
player_top_speed = 5 shot_speed = 11 player_accel = .5

spreadfire = 0 bombs = 3 double_guns = 0 missiles = 4
current_weapon=0
current_weapon_shape={}
weapon_switch_delay=4 weapon_switch_timer=0

sat_shot_length = 20

get_high_scores()

--Main game loop
while not quit do
    update_player()
    update_sats()
    update_enemies()
    update_rocks()
    update_bombs()
    update_missiles()
    update_shots()
    update_powerups()
    update_particles()
    if length(rocks)=0 and length(sats)=0 and length(enemy)=0 and
       length(powerups)=0 and player[ALIVE]>0 and not display_timer then
       display_timer = -50
    end if
    if find(pause_key, input) then
        input = {}
        VFcenter(24, "Paused", 9)
        --display_timer = display_timer - 1
        VFcenter(26, sprintf("Score %d", {score}), 4)
        VFcenter(28, sprintf("Level %d", {level}), 4)
        while get_key() = -1 do end while
        clear_keys()
        VFcenter(24, "Paused", 0)
        VFcenter(26, sprintf("Score %d", {score}), 0)
        VFcenter(28, sprintf("Level %d", {level}), 0)
    end if
    if player[ALIVE] < 0 then
        if high_score then
            VFcenter(2, "HIGH SCORE!", 3)
            New_High_Score()
        else
            VFcenter(2, "Press F2 to play, F10 to exit", 3)
            VFcenter(6, "Name   Score  Level", 3)
            for loop = 1 to 10 do
                VFcenter(loop+8, sprintf("%3s   %7d    %2d",
                  {scores[loop][NAME], scores[loop][SCORE], scores[loop][LEVEL]}),3)
            end for
            VFcenter(46, "Vector 1.0 Demo - Freeware", 3)
            VFcenter(47, "Copyright 1999 Robert Brandon Pilkington", 3)
            temp = get_key()
            clear_keys()
            display_timer = 2
            if temp = 316 then
                player={} rocks={} shots={} particles={} sats={} powerups={}
                bomb={} enemy={} missile={}
                quit = 0 level = 0 display_timer = 0 score = 0 high_score = 0
                player = Setup_Object(FIELDS)
                player[POS][X] = video_type[VC_XPIXELS]/2
                player[POS][Y] = video_type[VC_YPIXELS]/2
                player[VELOCITY][X]= 0 player[VELOCITY][Y]= 0
                player[ALIVE] = 4
                player[MAX_ALIVE] = 4
                player[SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
                player[COLOR] = 11
                player[SIZE] = 6
                player[ANGLE] = 270
                player[TAG] = 1
                player[WEAPON_RATE] = 8
                player[WEAPON_TIMER] = 0
                player_shot_length=20
                player_top_speed = 5 shot_speed = 11 player_accel = .5
                spreadfire = 0 bombs = 3 double_guns = 0 missiles = 4
                sat_shot_length = 20
                current_weapon=0
                current_weapon_shape={}
                weapon_switch_delay=4 weapon_switch_timer=0
                clear_screen()
                next_level()
            elsif temp = 324 then
                quit = 1
            end if
        end if
    end if
    if display_timer > 1 then
        display_timer = display_timer - 1
        VFcenter(26, sprintf("Score %d", {score}), 4)
        VFcenter(28, sprintf("Level %d", {level}), 4)
    elsif display_timer = 1 then
        display_timer = 0
        VFcenter(26, sprintf("Score %d", {score}), 0)
        VFcenter(28, sprintf("Level %d", {level}), 0)
    elsif display_timer < -1 then
        VFcenter(26, sprintf("Score %d", {score}), 4)
        VFcenter(28, sprintf("Level %d", {level}), 4)
        VFcenter(29, "Complete", 4)
        if length(shots)=0 and length(particles)=0 and length(bomb)=0 and
          length(missile)=0 then
            display_timer = display_timer + 1
        end if
    elsif display_timer = -1 then
        display_timer = 0
        clear_screen()
        player[POS][X] = floor(video_type[VC_XPIXELS]/2)
        player[POS][Y] = floor(video_type[VC_YPIXELS]/2)
        player[VELOCITY][X]= 0
        player[VELOCITY][Y]= 0
        player[SHAPE] = {{0,-5},{-5,5},{0,0},{5,5}}
        player[ANGLE] = 270
        next_level()
    end if
    tick_delay(1)
end while
-- Go and shut down and set everything back to normal now.
put_high_scores()
junk = graphics_mode(-1)            -- Restore graphics mode.
end procedure

play_game()                         -- Play

