-- Vector Font routines. Completely rewritten by Robert Pilkington for
-- much better performance but much less features. The only thing that is
-- the same as Peter Blue's version is it uses the same font. (But is stored
-- in a different format.)

-- Version 1.02 (2nd revision)
-- Changes:
-- Changed naming conventions and WAY optimized over 1.01
-- Uses Euphoria 2.1 features

include graphics.e

sequence TheFont
TheFont = repeat({},255)

--      Index  {{Vertice group 1},{Vertice group 2},{Vertice group n}}
TheFont[' '] = {}
TheFont['!'] = {{{4,1},{4,5}},{{4,7}}}
TheFont['"'] = {{{3,1},{3,2}},{{5,1},{5,2}}}
TheFont['#'] = {{{3,2},{3,6}},{{5,2},{5,6}},{{2,3},{6,3}},{{2,5},{6,5}}}
TheFont['$'] = {{{2,5},{3,6},{5,6},{6,5},{5,4},{3,4},{2,3},{3,2},{5,2},{6,3}},{{4,1},{4,7}}}
TheFont['%'] = {{{6,1},{2,7}},{{2,2},{3,2},{3,3},{2,3},{2,2}},{{5,5},{6,5},{6,6},{5,6},{5,5}}}
TheFont['&'] = {{{6,6},{2,2},{3,1},{4,1},{5,2},{2,5},{2,6},{3,7},{4,7},{6,5}}}
TheFont['\'']= {{{4,1},{4,2}}}
TheFont['('] = {{{4,1},{3,2},{3,6},{4,7}}}
TheFont[')'] = {{{4,1},{5,2},{5,6},{4,7}}} 
TheFont['*'] = {{{3,2},{5,6}},{{5,2},{3,6}},{{2,4},{6,4}}}
TheFont['+'] = {{{2,4},{6,4}},{{4,2},{4,6}}}
TheFont[','] = {{{4,6},{3,7}}}
TheFont['-'] = {{{2,4},{6,4}}}
TheFont['.'] = {{{4,7},{5,7}}}
TheFont['/'] = {{{6,1},{2,7}}}

-- Numbers
TheFont['0'] = {{{3,1},{5,1},{6,2},{6,6},{5,7},{3,7},{2,6},{2,2},{3,1}},{{6,2},{2,6}}}
TheFont['1'] = {{{2,2},{4,1},{4,7}},{{2,7},{6,7}}}
TheFont['2'] = {{{2,2},{3,1},{5,1},{6,2},{6,3},{2,7},{6,7}}}
TheFont['3'] = {{{2,2},{3,1},{5,1},{6,2},{6,3},{5,4},{6,5},{6,6},{5,7},{3,7},{2,6}}}
TheFont['4'] = {{{5,7},{5,1},{2,5},{6,5}}}
TheFont['5'] = {{{6,1},{2,1},{2,4},{3,3},{5,3},{6,4},{6,6},{5,7},{3,7},{2,6}}}
TheFont['6'] = {{{6,2},{5,1},{3,1},{2,2},{2,6},{3,7},{5,7},{6,6},{6,4},{5,3},{3,3},{2,4}}}
TheFont['7'] = {{{2,1},{6,1},{3,7}}}
TheFont['8'] = {{{3,1},{5,1},{6,2},{6,3},{5,4},{3,4},{2,5},{2,6},{3,7},{5,7},{6,6},{6,5},{5,4},{3,4},{2,3},{2,2},{3,1}}}
TheFont['9'] = {{{2,6},{3,7},{5,7},{6,6},{6,2},{5,1},{3,1},{2,2},{2,4},{3,5},{5,5},{6,4}}}
TheFont[':'] = {{{4,2},{4,2}},{{4,6},{4,6}}}
TheFont[';'] = {{{4,2},{4,2}},{{4,6},{3,7}}}
TheFont['<'] = {{{5,2},{3,4},{5,6}}}
TheFont['='] = {{{3,3},{5,3}},{{3,5},{5,5}}}
TheFont['>'] = {{{3,2},{5,4},{3,6}}}
TheFont['?'] = {{{2,2},{3,1},{5,1},{6,2},{6,4},{5,5},{4,5},{4,6}},{{4,8},{4,8}}}

-- Letters (Upper case)
TheFont['@'] = {{{6,6},{5,7},{3,7},{2,6},{2,2},{3,1},{5,1},{6,2},{6,5},{5,5},{5,3},{4,2},{3,3},{3,5},{4,6},{5,5}}}
TheFont['A'] = {{{2,7},{4,1},{6,7}},{{3,5},{5,5}}}
TheFont['B'] = {{{2,1},{5,1},{6,2},{6,3},{5,4},{6,5},{6,6},{5,7},{2,7},{2,1}},{{2,4},{5,4}}}
TheFont['C'] = {{{6,2},{5,1},{3,1},{2,2},{2,6},{3,7},{5,7},{6,6}}}
TheFont['D'] = {{{2,1},{5,1},{6,2},{6,6},{5,7},{2,7},{2,1}}}
TheFont['E'] = {{{6,1},{2,1},{2,7},{6,7}},{{2,4},{5,4}}}
TheFont['F'] = {{{6,1},{2,1},{2,7}},{{2,4},{5,4}}}
TheFont['G'] = {{{6,2},{5,1},{3,1},{2,2},{2,6},{3,7},{5,7},{6,6},{6,4},{4,4}}}
TheFont['H'] = {{{2,1},{2,7}},{{6,1},{6,7}},{{2,4},{6,4}}}
TheFont['I'] = {{{3,1},{5,1}},{{3,7},{5,7}},{{4,1},{4,7}}}
TheFont['J'] = {{{3,1},{5,1}},{{4,1},{4,6},{3,7}}}
TheFont['K'] = {{{2,1},{2,7}},{{2,4},{3,4},{6,1}},{{3,4},{6,7}}}
TheFont['L'] = {{{2,1},{2,7},{6,7}}}
TheFont['M'] = {{{2,7},{2,1},{4,4},{6,1},{6,7}}}
TheFont['N'] = {{{2,7},{2,1},{6,7},{6,1}}}
TheFont['O'] = {{{2,2},{3,1},{5,1},{6,2},{6,6},{5,7},{3,7},{2,6},{2,2}}}
TheFont['P'] = {{{2,7},{2,1},{5,1},{6,2},{6,3},{5,4},{2,4}}}
TheFont['Q'] = {{{2,2},{3,1},{5,1},{6,2},{6,6},{5,7},{3,7},{2,6},{2,2}},{{5,6},{6,7}}}
TheFont['R'] = {{{2,7},{2,1},{5,1},{6,2},{6,3},{5,4},{2,4}},{{5,4},{6,7}}}
TheFont['S'] = {{{2,6},{3,7},{5,7},{6,6},{6,5},{5,4},{3,4},{2,3},{2,2},{3,1},{5,1},{6,2}}}
TheFont['T'] = {{{2,1},{6,1}},{{4,1},{4,7}}}
TheFont['U'] = {{{2,1},{2,6},{3,7},{5,7},{6,6},{6,1}}}
TheFont['V'] = {{{2,1},{4,7},{6,1}}}
TheFont['W'] = {{{2,1},{3,7},{4,4},{5,7},{6,1}}}
TheFont['X'] = {{{2,1},{6,7}},{{6,1},{2,7}}}
TheFont['Y'] = {{{2,1},{4,4},{6,1}},{{4,4},{4,7}}}
TheFont['Z'] = {{{2,1},{6,1},{2,7},{6,7}}}
TheFont['['] = {{{5,1},{3,1},{3,7},{5,7}}}
TheFont['\\']= {{{2,1},{6,7}}}
TheFont[']'] = {{{3,1},{5,1},{5,7},{3,7}}}
TheFont['^'] = {{{3,3},{4,1},{5,3}}}
TheFont['_'] = {{{2,7},{6,7}}}

-- Letters (Lower case) For now, they count as uppercase.
TheFont['`'] = {{{4,1},{4,2},{5,3}}}
TheFont['a'] = TheFont['A'] --{{33,53,64,66,57,37,26,25,34,54,65,67}}
TheFont['b'] = TheFont['B'] --{{21,27},{24,33,53,64,66,57,37,26}}
TheFont['c'] = TheFont['C'] --{{64,53,33,24,26,37,57,66}}
TheFont['d'] = TheFont['D'] --{{61,67},{64,53,33,24,26,37,57,66}}
TheFont['e'] = TheFont['E'] --{{35,65,64,53,33,24,26,37,57,66}}
TheFont['f'] = TheFont['F'] --{{37,33,42,52,63},{34,54}}
TheFont['g'] = TheFont['G'] --{{63,67,58,38,27},{64,53,33,24,25,36,56,65}}
TheFont['h'] = TheFont['H'] --{{22,27},{25,34,54,65,67}}
TheFont['i'] = TheFont['I'] --{{37,57},{47,44,34},{43}}
TheFont['j'] = TheFont['J'] --{{34,44,47,38},{43}}
TheFont['k'] = TheFont['K'] --{{22,27},{57,25,53}}
TheFont['l'] = TheFont['L'] --{{37,57},{47,42,32}}
TheFont['m'] = TheFont['M'] --{{27,23},{24,33,44,53,64,67},{44,47}}
TheFont['n'] = TheFont['N'] --{{33,37},{34,43,53,64,67}}
TheFont['o'] = TheFont['O'] --{{24,33,53,64,66,57,37,26,24}}
TheFont['p'] = TheFont['P'] --{{23,28},{24,33,53,64,66,57,37,26}}
TheFont['q'] = TheFont['Q'] --{{63,68,77},{64,53,33,24,26,37,57,66}}
TheFont['r'] = TheFont['R'] --{{33,37},{34,43,53,64}}
TheFont['s'] = TheFont['S'] --{{26,37,57,66,55,35,24,33,53,64}}
TheFont['t'] = TheFont['T'] --{{32,36,47,56},{23,53}}
TheFont['u'] = TheFont['U'] --{{23,26,37,57,66},{63,67}}
TheFont['v'] = TheFont['V'] --{{23,47,63}}
TheFont['w'] = TheFont['W'] --{{23,37,45,57,63}}
TheFont['x'] = TheFont['X'] --{{23,67},{63,27}}
TheFont['y'] = TheFont['Y'] --{{63,67,58,38,27},{23,25,36,56,65}}
TheFont['z'] = TheFont['Z'] --{{23,63,27,67}}
TheFont['{'] = {{{4,1},{3,2},{3,3},{2,4},{3,5},{3,6},{4,7}}}
TheFont['|'] = {{{4,7},{4,1}}}
TheFont['}'] = {{{4,1},{5,2},{5,3},{6,4},{5,5},{5,6},{4,7}}}
TheFont['~'] = {{{2,4},{3,3},{5,5},{6,4}}}
TheFont[''] = {{{4,3},{5,4},{5,6},{3,6},{3,4},{4,3}}}

constant VecFont = TheFont,
         -- Change these if needed for other graphics modes:
         VF_XSIZE = 640,    -- For 640x480 resolution
         VF_MIDDLE= 40      -- 80 columns / 2 = 40
TheFont = {} -- Free up some memory

integer VFX, VFY, VFCOLOR
VFX = 1
VFY = 1
VFCOLOR = 7

global procedure VFputc(integer char)
    sequence c
    c = VecFont[char]
    for i = 1 to length(c) do
        for j = 1 to length(c[i]) do
            c[i][j] += {VFX, VFY}
        end for
        draw_line(VFCOLOR, c[i])
    end for
    VFX += 8
    if VFX > VF_XSIZE then
        VFX -= VF_XSIZE
        VFY += 10
    end if
end procedure

global procedure VFDisplay(sequence text, integer x, integer y, integer color)
    -- Displays a line at position X, Y.
    VFX = x*8
    VFY = y*10
    VFCOLOR = color
    for i = 1 to length(text) do
        VFputc(text[i])
    end for
end procedure

global procedure VFcenter(integer row, sequence string, integer color)
    -- Center the text on the screen.
    VFDisplay(string,floor(VF_MIDDLE-length(string)/2),row,color)
end procedure

